   'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   'x Uhr und Alarm optmierter LCD Anschluss        xxxxxxxx
   'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

   '$sim
   $regfile = "m8def.dat"
   $crystal = 16000000
   $hwstack = 100
   $swstack = 100
   $framesize = 100

   Dim Tstunde_stunde As Byte
   Dim Tminute_minute As Byte

   Dim Sekunde As Byte
   Dim Minute As Byte
   Dim Stunde As Byte
   Dim Tsekunde As Byte
   Dim Tminute As Byte
   Dim Tstunde As Byte
   Dim Esekunde As Byte
   Dim Eminute As Byte
   Dim Estunde As Byte

   Dim Aufab As Byte

   Dim S1 As String * 2                                     'Sekunde                                  '
   Dim S2 As String * 2                                     'Minute
   Dim S3 As String * 2                                     'Stunde

   Dim S4 As String * 2                                     'Tstunde
   Dim S5 As String * 2                                     'Tminute
   Dim S6 As String * 2                                     'Tsekunde

   Dim S7 As String * 2
   Dim S8 As String * 2
   Dim S9 As String * 2

   Config Lcdpin = Pin , Db7 = Portb.0 , Db6 = Portb.1 , Db5 = Portb.2 , _
      Db4 = Portb.3 , E = Portb.4 , Rs = Portb.5
   Config Lcd = 16 * 2
   Cls
   Cursor Off



   Config Timer1 = Timer , Prescale = 256
   Enable Timer1
   On Timer1 Takt
   Enable Interrupts
   Timer1 = 3036


'-----------------------------------------------


'Taster2 Uhr einstellen
Config Pind.1 = Input
Portd.1 = 1
Taster2 Alias Pind.1

'Taster3 Minuten einstellen
Config Pind.2 = Input
Portd.2 = 1
Taster3 Alias Pind.2

'Taster4 Alarm  einstellen Stunde
Config Pind.3 = Input
Portd.3 = 1
Taster4 Alias Pind.3

'Taster5 Alarm einstellen Minute
Config Pind.4 = Input
Portd.4 = 1
Taster5 Alias Pind.4

'Buzzer Port
Config Portc.5 = Output
Speaker Alias Portc.5

'LED definieren
Config Portd.6 = Output
Led Alias Portd.6



'--------------------Hauptprogramm----------------------------------------
Do

'--------------Einstellen Stunde ------------------------------------------

 Debounce Pind.1 , 0 , Stunde , Sub

'--------------Einstellen Minute ------------------------------------------

 Debounce Pind.2 , 0 , Minute , Sub

'--------------Alarm  einstellen Stunde -----------------------------------

 Debounce Pind.3 , 0 , Alarm_stunde , Sub

'--------------Alarm einstellen Minute ------------------------------------

 Debounce Pind.4 , 0 , Alarm_minute , Sub


'--------------Alarm Reset-------------------------------------------------

If Taster4 = 0 And Taster5 = 0 Then
   Wait 5
   Estunde = 0
   Eminute = 0
   Tstunde = 0
   Tminute = 0
End If

'--------------Sekunden zurckstellen-------------------------------------
If Taster2 = 0 And Taster3 = 0 Then
   Wait 5
   Sekunde = 0
End If

'-----------Einstellung Alarmzeit
 If Tsekunde = 59 Then Tminute = Tminute + 1
 If Tsekunde = 59 Then Tsekunde = 0
 If Tminute > 59 Then Tstunde = Tstunde + 1
 If Tminute > 59 Then Tminute = 0
 If Tstunde > 23 Then Tstunde = 0

'---Alarm auslsen


If Stunde = Tstunde And Minute = Tminute And Sekunde = Tsekunde Then

   Led = 1
   Sound Speaker , 50 , 1000                                'Lnge Tonhhe
   Sound Speaker , 262 , 637
   Sound Speaker , 220 , 758
   Sound Speaker , 175 , 954
   Sound Speaker , 294 , 566
   Sound Speaker , 233 , 715
   Sound Speaker , 196 , 850
   Sound Speaker , 262 , 637
   Sound Speaker , 220 , 758
   Sound Speaker , 175 , 954
   Sound Speaker , 784 , 850
      Wait 1
   Sound Speaker , 50 , 1000                                'Lnge Tonhhe
   Sound Speaker , 262 , 637
   Sound Speaker , 220 , 758
   Sound Speaker , 175 , 954
   Sound Speaker , 294 , 566
   Sound Speaker , 233 , 715
   Sound Speaker , 196 , 850
   Sound Speaker , 262 , 637
   Sound Speaker , 220 , 758
   Sound Speaker , 175 , 954
   Sound Speaker , 784 , 850

   Led = 0
   Estunde = 0
   Eminute = 0
   Tstunde = Stunde + Estunde
   Tminute = Minute + Eminute

 End If

'----------- Anzeige Stunden , Minuten, Sekunden auf Display ------------------

S1 = Str(sekunde)                                           'Uhr Stunde
S1 = Format(s1 , "00")
'----------------------------------
S2 = Str(minute)                                            'Uhr Minute
S2 = Format(s2 , "00")
'------------------------------------
S3 = Str(stunde)                                            'Uhr Sekunde
S3 = Format(s3 , "00")
'--------------------------------------

S4 = Str(tstunde)                                           'Alarm Stunde
S4 = Format(s4 , "00")
'----------------------------------
S5 = Str(tminute)                                           'Alarm Minute
S5 = Format(s5 , "00")
'------------------------------------
S6 = Str(tsekunde)                                          'Alarm Sekunde
S6 = Format(s6 , "00")

S7 = Str(estunde)
S7 = Format(s7 , "00")

S8 = Str(eminute)
S8 = Format(s8 , "00")

S9 = Str(esekunde)
S9 = Format(s9 , "00")


Locate 1 , 1
Lcd "Uhr:    " ; S3 ; ":" ; S2 ; ":" ; S1                   'Stunde-Minute-Sekunden
Locate 2 , 1
Lcd "AL: " ; S4 ; ":" ; S5 ; "  " ; S7 ; ":" ; S8           'Tstunde-Tminute-Tsekunde/Estunde-Eminute


Loop
End



Takt:
Timer1 = 3036
Incr Sekunde
If Sekunde = 60 Then
   Sekunde = 0
   Minute = Minute + 1
         If Minute = 60 Then
         Minute = 0
         Stunde = Stunde + 1
           If Stunde > 23 Then
           Stunde = 0
           End If
         End If
End If


Return
'------------SUB Einstellen Stunde ----------------------------------------
Stunde:
   Waitms 50
   Incr Stunde
         If Stunde > 23 Then
         Stunde = 00
         End If
Tstunde = Stunde + Estunde
Return

'------------SUB Einstellen Minute-----------------------------------------
Minute:
   Waitms 50
   Incr Minute
         If Minute > 59 Then
         Minute = 00
         End If
Tminute = Minute + Eminute
Return

'------------SUB Einstellen Alarm Stunde-----------------------------------
Alarm_stunde:
   Waitms 50
   Incr Estunde
         If Estunde > 23 Then
         Estunde = 00
         End If
Tstunde = Stunde + Estunde
Return

'------------SUB Einstellen Alarm Minute----------------------------------
Alarm_minute:
   Waitms 50
   Incr Eminute
         If Eminute > 59 Then
         Eminute = 00
         End If
Tminute = Minute + Eminute
Return